; GUI #
include win64a.inc
; --------------- 
yrot	equ xrot+4
yspeed	equ xspeed+4
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
;numtriangles = 36
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	hFile:qword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movaps	xmm0,xrot
	addps	xmm0,xspeed;	xrot+=xspeed
	movaps	xrot,xmm0;	yrot+=yspeed
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_SPACE
	jne	@f
	inc	object
	and 	object,3
	jmp	@0
@@:	cmp	al,VK_PRIOR
	jne	@f
	movd	xmm0,z
	subss	xmm0,const0_02;        z-=0.02
	movd	z,xmm0
	jmp	@0
@@:	cmp	al,VK_NEXT
	jne	@f
	movd	xmm0,z
	addss	xmm0,const0_02;        z+=0.02
	movd	z,xmm0
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f
	movd	xmm0,xspeed
	subss	xmm0,const0_01;xspeed-=0.01
	movd	xspeed,xmm0        
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	movd	xmm0,xspeed
	addss	xmm0,const0_01;xspeed+=0.01
	movd	xspeed,xmm0        
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	movd	xmm0,yspeed
	addss	xmm0,const0_01;yspeed+=0.01
	movd	yspeed,xmm0        
	jmp	@0
@@:	cmp	al,VK_LEFT
	jne	@f
	movd	xmm0,yspeed
	subss	xmm0,const0_01;yspeed-=0.01
	movd	yspeed,xmm0        
	jmp	@0
@@:	cmp	al,VK_F
	jne	@f
	inc	filter
	jnp	@0;if (filter>2)
	and	filter,0
	jmp	@0
@@:	cmp	al,VK_L
	jne	wmBYE
	mov	ecx,GL_LIGHTING
	xor	light,1;
	jnz	@f
	invoke	glDisable
	jmp	@0
@@:	invoke	glEnable
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,6
	xor	edi,edi
;Load Bitmaps And Convert To Textures-------------------------------------------------------
@@:	mov	qword ptr [rsp+20h],OPEN_EXISTING
	mov	qword ptr [rsp+28h],FILE_FLAG_SEQUENTIAL_SCAN
	mov	[rsp+30h],rbx
	mov	rcx,FileName2[rdi*8]
	invoke	CreateFile,,GENERIC_READ,0,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,rax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
    	mov	eax,[rsi + BITMAPINFOHEADER.biWidth + sizeof BITMAPFILEHEADER]
        mov	w,eax
        movzx	eax, word ptr [rsi + BITMAPINFOHEADER.biHeight + sizeof BITMAPFILEHEADER]
        mov	h,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	imul	edi,12
	mov	edx,Texture1_Id[rdi]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	mov	[rsp+20h],rax
	mov	[rsp+28h],rbx
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	[rsp+40h],rsi
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST
	mov	edx,Texture1_Id[rdi+4]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	mov	[rsp+20h],rax
	mov	[rsp+28h],rbx
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	[rsp+40h],rsi
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	mov	edx,Texture1_Id[rdi+8]
	invoke	glBindTexture,GL_TEXTURE_2D

	mov	r8d,w
        mov	r9d,h
	mov	qword ptr [rsp+20h],GL_RGB;GL_BGR_EXT
	mov	qword ptr [rsp+28h],GL_UNSIGNED_BYTE
	mov	[rsp+30h],rsi
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,3

	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST
	invoke	GlobalFree,texture
	inc	edi
	cmp	edi,13
	jb	@b
        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;Enables Clearing Of The Depth Buffer
	invoke	glEnable,GL_DEPTH_TEST ;Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations
	mov	r8d,offset LightAmbient
	invoke	glLightfv,GL_LIGHT1, GL_AMBIENT; Setup The Ambient Light
	mov	r8d,offset LightDiffuse
	invoke	glLightfv,GL_LIGHT1, GL_DIFFUSE; Setup The Diffuse Light
	mov	r8d,offset LightPosition
	invoke	glLightfv,GL_LIGHT1, GL_POSITION; Position The Light
	invoke	glEnable,GL_LIGHT1; Enable Light One
	invoke	gluNewQuadric;							// Create A Pointer To The Quadric Object (Return 0 If No Memory)
	mov	quadratic,rax
	invoke	gluQuadricNormals,eax, GLU_SMOOTH; Create Smooth Normals 
	invoke	gluQuadricTexture,quadratic, GL_TRUE; Create Texture Coords 

	invoke	glTexGeni,GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP;  Set The Texture Generation Mode For S To Sphere Mapping (NEW)
	invoke	glTexGeni,GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP;  Set The Texture Generation Mode For T To Sphere Mapping (NEW)
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
	movss	xmm2,z
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-2		 Move Into The Screen 5 Units

	invoke	glEnable,GL_TEXTURE_GEN_S;	Enable Texture Coord Generation For S
	invoke	glEnable,GL_TEXTURE_GEN_T;	Enable Texture Coord Generation For T
	mov	eax,filter
	mov	edx,Texture1_Id[rax*4+12]
	invoke	glBindTexture,GL_TEXTURE_2D; This Will Select The Sphere Map
	invoke	glPushMatrix
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,xrot
	invoke	glRotatef;xrot,1,0,0;

	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,yrot
	invoke	glRotatef;yrot,0,1,0;

	mov	eax,object
	jmp	handler[rax*8]
case0:	invoke	glDrawCube
	jmp	@f
case1:	movd	xmm2,const_1_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-1.5	 Center The Cylinder
	movq	xmm3,constd3
	movq	xmm2,constd1
	movsd	xmm1,xmm2
	invoke	gluCylinder,quadratic,,,,32,32; A Cylinder With A Radius Of 0.5 And A Height Of 2
	jmp	@f
case2:	movq	xmm1,constd1_3
	invoke	gluSphere,quadratic,,32,32; Draw A Sphere With A Radius Of 1 And 16 Longitude And 16 Latitude Segments
	jmp	@f
case3:	movd	xmm2,const_1_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-1.5	 Center The Cone
	movq	xmm3,constd3
	xorps	xmm2,xmm2
	movq	xmm1,constd1
	invoke	gluCylinder,quadratic,,,,32,32; A Cone With A Bottom Radius Of .5 And A Height Of 2
@@:	invoke	glPopMatrix
	invoke	glDisable,GL_TEXTURE_GEN_S
	invoke	glDisable,GL_TEXTURE_GEN_T
	mov	eax,filter
	mov	edx,Texture1_Id[rax*2]
	invoke	glBindTexture,GL_TEXTURE_2D;	This Will Select The BG Maps...
	invoke	glPushMatrix
	movd	xmm2,const_24
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0, 0, -24.0;
	invoke	glBegin,GL_QUADS
	movd	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0, 1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0;
	movd	xmm2,const10
	movd	xmm1,const_10
	movd	xmm0,const_13_3 
	invoke	glVertex3f;-13.3, -10.0,  10.0;
	xorps	xmm1,xmm1
	movd	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movd	xmm2,const10
	movd	xmm1,const_10
	movd	xmm0,const13_3 
	invoke	glVertex3f; 13.3, -10.0,  10.0;
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movd	xmm2,const10
	movss	xmm1,xmm2
	movd	xmm0,const13_3 
	invoke	glVertex3f; 13.3,  10.0,  10.0;
	movd	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movd	xmm2,const10
	movss	xmm1,xmm2
	movd	xmm0,const_13_3 
	invoke	glVertex3f;-13.3,  10.0,  10.0;
	invoke	glEnd
	invoke	glPopMatrix
	invoke	glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
handler dq case0,case1,case2,case3
WndProc	endp
glDrawCube proc
	enter	20h,0
	invoke	glBegin,GL_QUADS
; Front Face
	movss	xmm2,const0_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0, 0.5;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1, -1,  1;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f; 1, -1,  1;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; 1,  1,  1;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f;-1,  1,  1;
; Back Face
	movss	xmm2,const_0_5
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0,-0.5;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;-1, -1, -1;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,  1, -1;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1,  1, -1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f; 1, -1, -1;
; Top Face
	xorps	xmm2,xmm2
	movss	xmm1,const0_5
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0, 0.5, 0;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1,  1, -1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f;-1,  1,  1;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; 1,  1,  1;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1,  1, -1;
; Bottom Face
	xorps	xmm2,xmm2
	movss	xmm1,const_0_5
	xorps	xmm0,xmm0
	invoke	glNormal3f; 0,-0.5, 0;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;-1, -1, -1;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f; 1, -1, -1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f; 1, -1,  1;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1, -1,  1;
; Right Face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const0_5
	invoke	glNormal3f; 0.5, 0, 0;
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glVertex3f; 1, -1, -1;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1,  1, -1;
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f; 1,  1,  1;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glVertex3f; 1, -1,  1;
; Left Face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_0_5
	invoke	glNormal3f;-0.5, 0, 0;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glVertex3f;-1, -1, -1
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1, -1, 1;
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
	invoke	glVertex3f;-1, 1, 1
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glVertex3f;-1, 1, -1
	invoke	glEnd
	leave
	ret
glDrawCube endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#23: Sphere Mapping Quadrics In OpenGL",0
FileName	db "br_Rabbit3.cur",0
BG_file	db "BG.bmp",0
Reflect_file db "Reflect.bmp",0
FileName2 dq BG_file,Reflect_file
light	db ?; Lighting ON/OFF
z	dd -10.0; Depth Into The Screen
quadratic dq ?;	// Storage For Our Quadratic Objects
LightAmbient dd 0.5, 0.5, 0.5, 1.0;
LightDiffuse dd 1.0, 1.0, 1.0, 1.0;
LightPosition dd 0.0, 0.0, 2.0, 1.0;
object	dd 1; Which Object To Draw
filter dd ?; Which Filter To Use
texture		dq ?
Texture1_Id	dd ?,?,?,?,?,?;Storage For 6 Textures

;-----------------------------
;float
const0_01	dd 0.01
const0_02	dd 0.02
const0_5	dd 0.5
const_0_5	dd -0.5
const1		dd 1.0
const_1		dd -1.0
const_1_5	dd -1.5
const4		dd 4.0
const10		dd 10.0
const_10	dd -10.0
const13_3	dd 13.3
const_13_3	dd -13.3
const_24	dd -24.0
const360	dd 360.0
;double
constd0_1	dq 0.1
constd1		dq 1.0
constd1_3	dq 1.3
constd3		dq 3.0
constd45	dq 45.0
constd100	dq 100.0
align 16
xrot	dd 0,0,0,0; Y Rotation
xspeed	dd 0,0,0,0; Y Rotation Speed
end